// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from soccer_object_msgs:msg/FieldLine.idl
// generated code does not contain a copyright notice

#ifndef SOCCER_OBJECT_MSGS__MSG__DETAIL__FIELD_LINE__TRAITS_HPP_
#define SOCCER_OBJECT_MSGS__MSG__DETAIL__FIELD_LINE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "soccer_object_msgs/msg/detail/field_line__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'start'
// Member 'end'
#include "geometry_msgs/msg/detail/point__traits.hpp"

namespace soccer_object_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const FieldLine & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: start
  {
    out << "start: ";
    to_flow_style_yaml(msg.start, out);
    out << ", ";
  }

  // member: end
  {
    out << "end: ";
    to_flow_style_yaml(msg.end, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FieldLine & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: start
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start:\n";
    to_block_style_yaml(msg.start, out, indentation + 2);
  }

  // member: end
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "end:\n";
    to_block_style_yaml(msg.end, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FieldLine & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace soccer_object_msgs

namespace rosidl_generator_traits
{

[[deprecated("use soccer_object_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const soccer_object_msgs::msg::FieldLine & msg,
  std::ostream & out, size_t indentation = 0)
{
  soccer_object_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use soccer_object_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const soccer_object_msgs::msg::FieldLine & msg)
{
  return soccer_object_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<soccer_object_msgs::msg::FieldLine>()
{
  return "soccer_object_msgs::msg::FieldLine";
}

template<>
inline const char * name<soccer_object_msgs::msg::FieldLine>()
{
  return "soccer_object_msgs/msg/FieldLine";
}

template<>
struct has_fixed_size<soccer_object_msgs::msg::FieldLine>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Point>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<soccer_object_msgs::msg::FieldLine>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Point>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<soccer_object_msgs::msg::FieldLine>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SOCCER_OBJECT_MSGS__MSG__DETAIL__FIELD_LINE__TRAITS_HPP_
