// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from soccer_object_msgs:msg/FieldLineArray.idl
// generated code does not contain a copyright notice

#ifndef SOCCER_OBJECT_MSGS__MSG__DETAIL__FIELD_LINE_ARRAY__TRAITS_HPP_
#define SOCCER_OBJECT_MSGS__MSG__DETAIL__FIELD_LINE_ARRAY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "soccer_object_msgs/msg/detail/field_line_array__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'lines'
#include "soccer_object_msgs/msg/detail/field_line__traits.hpp"

namespace soccer_object_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const FieldLineArray & msg,
  std::ostream & out)
{
  out << "{";
  // member: lines
  {
    if (msg.lines.size() == 0) {
      out << "lines: []";
    } else {
      out << "lines: [";
      size_t pending_items = msg.lines.size();
      for (auto item : msg.lines) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FieldLineArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: lines
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.lines.size() == 0) {
      out << "lines: []\n";
    } else {
      out << "lines:\n";
      for (auto item : msg.lines) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FieldLineArray & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace soccer_object_msgs

namespace rosidl_generator_traits
{

[[deprecated("use soccer_object_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const soccer_object_msgs::msg::FieldLineArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  soccer_object_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use soccer_object_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const soccer_object_msgs::msg::FieldLineArray & msg)
{
  return soccer_object_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<soccer_object_msgs::msg::FieldLineArray>()
{
  return "soccer_object_msgs::msg::FieldLineArray";
}

template<>
inline const char * name<soccer_object_msgs::msg::FieldLineArray>()
{
  return "soccer_object_msgs/msg/FieldLineArray";
}

template<>
struct has_fixed_size<soccer_object_msgs::msg::FieldLineArray>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<soccer_object_msgs::msg::FieldLineArray>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<soccer_object_msgs::msg::FieldLineArray>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SOCCER_OBJECT_MSGS__MSG__DETAIL__FIELD_LINE_ARRAY__TRAITS_HPP_
