// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from soccer_object_msgs:msg/Goalpost.idl
// generated code does not contain a copyright notice

#ifndef SOCCER_OBJECT_MSGS__MSG__DETAIL__GOALPOST__STRUCT_H_
#define SOCCER_OBJECT_MSGS__MSG__DETAIL__GOALPOST__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'point'
#include "geometry_msgs/msg/detail/point__struct.h"

/// Struct defined in msg/Goalpost in the package soccer_object_msgs.
/**
  * Contains information about an observed goalpost.
  * NOTE: There are two options for populating this message
  *
  * Either:
  *   If the top point of the post was detected, set "observed_top" to true and populate "top".
  *      This is needed because rcssserver3d reports to the top of the goal post to the agents.
  * If the bottom of a post was detected ,set "observed_top" to false and populate "bot".
  *      This can be used as a replacement for physical robots that might detect the bottom
  *      of the post, rather than the top
  *
  * Any node that listens to this message MUST consider both cases.
 */
typedef struct soccer_object_msgs__msg__Goalpost
{
  std_msgs__msg__Header header;
  bool observed_top;
  geometry_msgs__msg__Point point;
} soccer_object_msgs__msg__Goalpost;

// Struct for a sequence of soccer_object_msgs__msg__Goalpost.
typedef struct soccer_object_msgs__msg__Goalpost__Sequence
{
  soccer_object_msgs__msg__Goalpost * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} soccer_object_msgs__msg__Goalpost__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // SOCCER_OBJECT_MSGS__MSG__DETAIL__GOALPOST__STRUCT_H_
