// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from soccer_object_msgs:msg/Robot.idl
// generated code does not contain a copyright notice

#ifndef SOCCER_OBJECT_MSGS__MSG__DETAIL__ROBOT__STRUCT_H_
#define SOCCER_OBJECT_MSGS__MSG__DETAIL__ROBOT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'head'
#include "geometry_msgs/msg/detail/point__struct.h"
// Member 'team'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/Robot in the package soccer_object_msgs.
/**
  * Data type for robot observation in vision.
  * Due to how robot observations are sent in SimSpark, this data message uses the "head" point
  * of the robot.
 */
typedef struct soccer_object_msgs__msg__Robot
{
  std_msgs__msg__Header header;
  geometry_msgs__msg__Point head;
  /// (Optional) Team Name, empty string indicated "unknown"
  rosidl_runtime_c__String team;
  /// (Optional) Player Id, 0 indicates "unknown"
  int32_t id;
} soccer_object_msgs__msg__Robot;

// Struct for a sequence of soccer_object_msgs__msg__Robot.
typedef struct soccer_object_msgs__msg__Robot__Sequence
{
  soccer_object_msgs__msg__Robot * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} soccer_object_msgs__msg__Robot__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // SOCCER_OBJECT_MSGS__MSG__DETAIL__ROBOT__STRUCT_H_
