// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from soccer_object_msgs:msg/Robot.idl
// generated code does not contain a copyright notice

#ifndef SOCCER_OBJECT_MSGS__MSG__DETAIL__ROBOT__STRUCT_HPP_
#define SOCCER_OBJECT_MSGS__MSG__DETAIL__ROBOT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'head'
#include "geometry_msgs/msg/detail/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__soccer_object_msgs__msg__Robot __attribute__((deprecated))
#else
# define DEPRECATED__soccer_object_msgs__msg__Robot __declspec(deprecated)
#endif

namespace soccer_object_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Robot_
{
  using Type = Robot_<ContainerAllocator>;

  explicit Robot_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    head(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->team = "";
      this->id = 0l;
    }
  }

  explicit Robot_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    head(_alloc, _init),
    team(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->team = "";
      this->id = 0l;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _head_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _head_type head;
  using _team_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _team_type team;
  using _id_type =
    int32_t;
  _id_type id;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__head(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->head = _arg;
    return *this;
  }
  Type & set__team(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->team = _arg;
    return *this;
  }
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    soccer_object_msgs::msg::Robot_<ContainerAllocator> *;
  using ConstRawPtr =
    const soccer_object_msgs::msg::Robot_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<soccer_object_msgs::msg::Robot_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<soccer_object_msgs::msg::Robot_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      soccer_object_msgs::msg::Robot_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<soccer_object_msgs::msg::Robot_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      soccer_object_msgs::msg::Robot_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<soccer_object_msgs::msg::Robot_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<soccer_object_msgs::msg::Robot_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<soccer_object_msgs::msg::Robot_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__soccer_object_msgs__msg__Robot
    std::shared_ptr<soccer_object_msgs::msg::Robot_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__soccer_object_msgs__msg__Robot
    std::shared_ptr<soccer_object_msgs::msg::Robot_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Robot_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->head != other.head) {
      return false;
    }
    if (this->team != other.team) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    return true;
  }
  bool operator!=(const Robot_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Robot_

// alias to use template instance with default allocator
using Robot =
  soccer_object_msgs::msg::Robot_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace soccer_object_msgs

#endif  // SOCCER_OBJECT_MSGS__MSG__DETAIL__ROBOT__STRUCT_HPP_
