// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from soccer_object_msgs:msg/Robot.idl
// generated code does not contain a copyright notice

#ifndef SOCCER_OBJECT_MSGS__MSG__DETAIL__ROBOT__TRAITS_HPP_
#define SOCCER_OBJECT_MSGS__MSG__DETAIL__ROBOT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "soccer_object_msgs/msg/detail/robot__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'head'
#include "geometry_msgs/msg/detail/point__traits.hpp"

namespace soccer_object_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Robot & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: head
  {
    out << "head: ";
    to_flow_style_yaml(msg.head, out);
    out << ", ";
  }

  // member: team
  {
    out << "team: ";
    rosidl_generator_traits::value_to_yaml(msg.team, out);
    out << ", ";
  }

  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Robot & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: head
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "head:\n";
    to_block_style_yaml(msg.head, out, indentation + 2);
  }

  // member: team
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "team: ";
    rosidl_generator_traits::value_to_yaml(msg.team, out);
    out << "\n";
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Robot & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace soccer_object_msgs

namespace rosidl_generator_traits
{

[[deprecated("use soccer_object_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const soccer_object_msgs::msg::Robot & msg,
  std::ostream & out, size_t indentation = 0)
{
  soccer_object_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use soccer_object_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const soccer_object_msgs::msg::Robot & msg)
{
  return soccer_object_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<soccer_object_msgs::msg::Robot>()
{
  return "soccer_object_msgs::msg::Robot";
}

template<>
inline const char * name<soccer_object_msgs::msg::Robot>()
{
  return "soccer_object_msgs/msg/Robot";
}

template<>
struct has_fixed_size<soccer_object_msgs::msg::Robot>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<soccer_object_msgs::msg::Robot>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<soccer_object_msgs::msg::Robot>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SOCCER_OBJECT_MSGS__MSG__DETAIL__ROBOT__TRAITS_HPP_
